Package com.stardog.stark.query

# Interface Dataset

All Known Implementing Classes:
  `Datasets.DatasetImpl`

public interface Dataset

Amalgum of an RDF 1.1 Dataset, a SPARQL 1.1 RDF Dataset & a SPARQL 1.1 update [graph](https://www.w3.org/TR/sparql11-update/#deleteInsert)

Both RDF 1.1 and SPARQL specify that there is a single default graph per Dataset. However, with SPARQL 1.1 you can specify multiple graphs and the single default graph is presumed to be the RDF merge of the `specified graphs`

This Dataset representation takes the RDF 1.1 position wrt to graph names; both bnodes and IRIs are legal identifiers.

Since:
  1.0
Author:
  Michael Grove

- ## Method Summary

  Modifier and Type
  Method
  Description
  `com.google.common.collect.ImmutableSet<Resource>`
  `defaultGraphs()`
  The set of graphs, the union of which, makes up the default component of the active graph
  `Optional<Resource>`
  `defaultInsertGraph()`
  Optionally, the graph where write queries should insert data.
  `com.google.common.collect.ImmutableSet<Resource>`
  `defaultRemoveGraphs()`
  The set of graphs write queries can remove data from.
  `com.google.common.collect.ImmutableSet<Resource>`
  `excludedGraphs()`
  The set of graphs to be excluded from the query dataset.
  `default boolean`
  `isEmpty()`
  `com.google.common.collect.ImmutableSet<Resource>`
  `namedGraphs()`
  The set of named graphs that are a part of the active graph of the dataset.

- ## Method Details

  - ### isEmpty

    default boolean isEmpty()

  - ### defaultRemoveGraphs

    @Nonnull com.google.common.collect.ImmutableSet<Resource> defaultRemoveGraphs()
    The set of graphs write queries can remove data from.
    Returns:
      the graphs

  - ### defaultInsertGraph

    @Nonnull Optional<Resource> defaultInsertGraph()
    Optionally, the graph where write queries should insert data.
    Returns:
      the graph to insert into

  - ### defaultGraphs

    @Nonnull com.google.common.collect.ImmutableSet<Resource> defaultGraphs()
    The set of graphs, the union of which, makes up the default component of the active graph
    Returns:
      the default graphs; when empty, the default graph of the database is used

  - ### namedGraphs

    @Nonnull com.google.common.collect.ImmutableSet<Resource> namedGraphs()
    The set of named graphs that are a part of the active graph of the dataset.
    Returns:
      the named graphs

  - ### excludedGraphs

    @Nonnull com.google.common.collect.ImmutableSet<Resource> excludedGraphs()
    The set of graphs to be excluded from the query dataset. Returns the set of graphs, possibly including wildcards, excluded from both the default and named scope of the dataset.